// ColorPickerDlg.cpp : implementation file
//

 #include "stdafx.h"
#include "ColorPicker.h"
#include "ColorPickerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorPickerDlg dialog

CColorPickerDlg::CColorPickerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CColorPickerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColorPickerDlg)
	m_bShowModal = FALSE;
	m_iMode = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CColorPickerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColorPickerDlg)
	DDX_Control(pDX, IDC_COLOR, m_ctrlColor);
	DDX_Check(pDX, IDC_SHOWMODAL, m_bShowModal);
	DDX_Radio(pDX, IDC_HEXA, m_iMode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CColorPickerDlg, CDialog)
	//{{AFX_MSG_MAP(CColorPickerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SHOWMODAL, OnShowModal)
	ON_BN_CLICKED(IDC_HEXA, OnHexa)
	ON_BN_CLICKED(IDC_HTML, OnHtml)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorPickerDlg message handlers

BOOL CColorPickerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	m_nTimer = 1;
	m_bShowModal = true;
	m_iMode = 1;
	m_bHexa = false;
	UpdateData(false);
	SetTimer(m_nTimer,10,NULL);
	SetWindowPos(&wndTopMost,0,0,0,0,SWP_SHOWWINDOW|SWP_NOSIZE|SWP_NOMOVE);
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CColorPickerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CColorPickerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CColorPickerDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CPoint point;
	char str[10];
	COLORREF c;
	CString strColor;
	HDC hDC;
	short r,g,b;

	hDC = CreateDC("DISPLAY",0,0,0);
	GetCursorPos(&point);
	c = GetPixel(hDC,point.x,point.y);
	r = GetRValue(c);
	g = GetGValue(c);
	b = GetBValue(c);
	if (m_bHexa)
		 sprintf(str,"%02x%02x%02x",b,g,r);
	else sprintf(str,"%02x%02x%02x",r,g,b);
	strupr(str);

	if (c == 0) strcpy(str,"000000");
	if (m_bHexa) 
		 strColor = "0x";
	else strColor = "#";
	strColor += str;

	m_ctrlColor.SetWindowText(strColor);
	m_ctrlColor.UpdateData(false);
	
	DeleteDC(hDC);
	
	if ((GetAsyncKeyState(VK_SPACE))!=0)
	{
		m_ctrlColor.SetSel(0,8,false);	
		m_ctrlColor.Copy();	
	}

	CDialog::OnTimer(nIDEvent);
}

void CColorPickerDlg::OnShowModal() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (m_bShowModal)
		SetWindowPos(&wndTopMost,0,0,0,0,SWP_SHOWWINDOW|SWP_NOSIZE|SWP_NOMOVE);
	else 
		SetWindowPos(&wndNoTopMost,0,0,0,0,SWP_SHOWWINDOW|SWP_NOSIZE|SWP_NOMOVE);
	m_ctrlColor.SetFocus();
}

BOOL CColorPickerDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	KillTimer(m_nTimer);
	return CDialog::DestroyWindow();
}


void CColorPickerDlg::OnHexa() 
{
	// TODO: Add your control notification handler code here
	m_bHexa = true;
	m_ctrlColor.SetFocus();
}

void CColorPickerDlg::OnHtml() 
{
	// TODO: Add your control notification handler code here
	m_bHexa = false;
	m_ctrlColor.SetFocus();
}
